//   GreKo chess engine
//   (c) 2002-2021 Vladimir Medvedev <vrm@bk.ru>
//   http://greko.su

#ifndef EVAL_PARAMS_H
#define EVAL_PARAMS_H

#include "types.h"

// const int PSQ_LENGTH = 5;
// const int PSQ_LENGTH = 12;
// const int PSQ_LENGTH = 16;
const int PSQ_LENGTH = 64;

// #define FEATURES_LINEAR
// #define FEATURES_QUADRATIC
#define FEATURES_TABULAR

extern size_t Pawn;
extern size_t Knight;
extern size_t Bishop;
extern size_t Rook;
extern size_t Queen;
extern size_t King;

extern size_t NUMBER_OF_FEATURES;
extern vector<double> g_w;

template<typename W, typename F>
double DotProduct(const W weights, const F features)
{
	assert(weights.size() == features.size());

	double e = 0;
	for (size_t i = 0; i < weights.size(); ++i)
		e += weights[i] * features[i];
	return e;
}
////////////////////////////////////////////////////////////////////////////////

void InitFeatures();
string FeatureName(size_t index);
bool ReadWeights(vector<double>& x, const string& file);
void SetDefaultWeights(vector<double>& x);
void WriteWeights(const vector<double>& x, const string& file);

#endif
